# pylint: disable=too-many-return-statements,inconsistent-return-statements
# pylint: disable=too-few-public-methods

"""
Common Variables and Mock Class Objects used for testing the three-plus
dish observing mode
"""

import katpoint
import numpy
import pandas
from astropy.coordinates import EarthLocation, SkyCoord
from astropy.units import Quantity
from ska_sdp_datamodels.science_data_model.polarisation_model import (
    PolarisationFrame,
)
from ska_sdp_datamodels.visibility.vis_utils import generate_baselines

from ska_sdp_wflow_pointing_offset import construct_antennas

PREFIX = "/__test_pointing"

NSCANS = 5
NTIMES = 5
NANTS = 3
NCHAN = 64
NCORR = 15
NPOL = 2
BEAMWIDTH_FACTOR = (0.96, 1.098)
THRESH_WIDTH = 1.15


SOURCE_NAME = "J1939-6342"
PHASECENTRE = SkyCoord(294.85429167, -63.71266667, unit="deg")


# Define the parameters for fit primary beam function
CORR_TYPE = ["XX", "YY"]
LINEAR_POLFRAME = PolarisationFrame("linear")  # ["XX", "XY", "YX", "YY"]
LINEARNP_POLFRAME = PolarisationFrame("linearnp")  # ["XX", "YY"]
STOKESI_POLFRAME = PolarisationFrame("stokesI")  # ["I"]

BASELINES = pandas.MultiIndex.from_tuples(
    generate_baselines(NANTS), names=("antenna1", "antenna2")
)

# Pointing calibrator position
SOURCE_POSITION = numpy.array([[5.14618, -1.112], [0, 0]])
TARGET = katpoint.construct_radec_target(
    ra=SOURCE_POSITION[0][0], dec=SOURCE_POSITION[0][1]
)

# Complex visibilities, weights, and flags
VIS = numpy.full(
    (NTIMES, len(BASELINES), NCHAN, NPOL), numpy.complex128(1.0 + 0.01j)
)
VIS_WEIGHTS = numpy.ones(VIS.shape)
FLAGS = numpy.zeros(VIS.shape)

INTEGRATION_TIME = numpy.array(
    [7.99661697, 7.99661697, 7.99661697, 7.99661697, 7.99661697]
)
INTERVAL = numpy.array(
    [7.99661732, 7.99661732, 23.98985195, 7.99661636, 23.98985195]
)
FREQS = numpy.linspace(1326000000.0, 1367000000.0, NCHAN)
CHANNEL_BANDWIDTH = numpy.full(FREQS.shape, 372281.909)

MOUNT = ["ALT-AZ", "ALT-AZ", "ALT-AZ"]
OFFSET = numpy.array(
    [
        [0.00000000e00, 0.00000000e00, 0.00000000e00],
        [2.18848512e-03, 0.00000000e00, 0.00000000e00],
        [-3.02790361e-03, 0.00000000e00, 0.00000000e00],
    ]
)


# Reference timestamp and its corresponding commanded AzEl
REFERENCE_MJD = numpy.array(5179444807.996635)
REFERENCE_COMMANDED_AZEL = numpy.full((NANTS, 2), [148.94149955, 33.39730193])


UVW = numpy.array(
    [
        [
            [0.0, 0.0, 0.0],
            [-397.89452612, 584.1169983, -153.35096251],
            [-1357.78172302, 56.39427491, -30.15833161],
            [-33.08582193, -422.93637971, 107.28705751],
            [0.0, 0.0, 0.0],
            [-959.8871969, -527.7227234, 123.1926309],
        ],
        [
            [0.0, 0.0, 0.0],
            [-397.67291131, 584.32154768, -153.14641314],
            [-1357.76787287, 57.09247337, -29.46013315],
            [-33.24812717, -422.9193245, 107.30411272],
            [0.0, 0.0, 0.0],
            [-960.09496157, -527.2290743, 123.68627999],
        ],
        [
            [0.0, 0.0, 0.0],
            [-397.45108619, 584.52598303, -152.94197778],
            [-1357.75330468, 57.79066453, -28.76194199],
            [-33.41041483, -422.90218584, 107.32125138],
            [0.0, 0.0, 0.0],
            [-960.30221849, -526.7353185, 124.18003579],
        ],
        [
            [0.0, 0.0, 0.0],
            [-397.22905088, 584.73030427, -152.73765654],
            [-1357.73801843, 58.48884802, -28.0637585],
            [-33.57268481, -422.88496373, 107.33847349],
            [0.0, 0.0, 0.0],
            [-960.50896755, -526.24145625, 124.67389804],
        ],
        [
            [0.0, 0.0, 0.0],
            [-397.0068055, 584.93451128, -152.53344954],
            [-1357.72201414, 59.18702345, -27.36558307],
            [-33.73493705, -422.86765818, 107.35577904],
            [0.0, 0.0, 0.0],
            [-960.71520865, -525.74748782, 125.16786647],
        ],
    ]
)

XYZ = numpy.array(
    [
        [5109271.497354163, 2006808.8930278125, -3239130.7361407224],
        [5109284.8540775385, 2006824.2217235335, -3239100.126460417],
        [5109272.199343496, 2006783.5460499495, -3239145.330041681],
    ]
)
LOCATION = EarthLocation(
    x=Quantity(XYZ[0][0], "m"),
    y=Quantity(XYZ[0][1], "m"),
    z=Quantity(XYZ[0][2], "m"),
)
DIAMETER = numpy.array([13.5, 13.5, 13.5])
ANTENNA_NAME = [
    "M001",
    "M002",
    "M003",
]
ANTS = construct_antennas(XYZ, DIAMETER, ANTENNA_NAME)


VIS_TIMESTAMPS_MJD = numpy.array(
    [5.17944476e09, 5.17944477e09, 5.17944480e09, 5.17944483e09, 5.17944487e09]
)
POINTING_TIMESTAMPS_MJD = numpy.array(
    [
        5179444770.00002,
        5179444780.000006,
        5179444800.000018,
        5179444810.000004,
        5179444830.000016,
        5179444770.00002,
        5179444780.000006,
        5179444800.000018,
        5179444810.000004,
        5179444830.000016,
        5179444770.00002,
        5179444780.000006,
        5179444800.000018,
        5179444810.000004,
        5179444830.000016,
    ]
)


# Commanded pointings in azel (in radians)
COMMANDED_POINTING_AZ = numpy.array(
    [
        [2.59951956],
        [2.5995292],
        [2.59954084],
        [2.59952341],
        [2.59953468],
        [2.5995555],
        [2.59951115],
        [2.59952839],
        [2.59953774],
        [2.59952332],
        [2.59951467],
        [2.59954651],
        [2.59951795],
        [2.59953602],
        [2.59953813],
    ]
)

COMMANDED_POINTING_EL = numpy.array(
    [
        [0.58289288],
        [0.58315322],
        [0.59556616],
        [0.58289054],
        [0.58314426],
        [0.59555126],
        [0.59453202],
        [0.59477974],
        [0.60720319],
        [0.5945226],
        [0.59478267],
        [0.60719505],
        [0.60616343],
        [0.60642124],
        [0.61882641],
    ]
)


# Actual pointings in azel (in radians)
ACTUAL_POINTING_AZ = numpy.array(
    [
        [2.59951985],
        [2.59952987],
        [2.5995404],
        [2.59952153],
        [2.59953245],
        [2.59955601],
        [2.59951979],
        [2.59952602],
        [2.59954315],
        [2.59951561],
        [2.5995195],
        [2.59954782],
        [2.59951586],
        [2.59953649],
        [2.59954347],
    ]
)

ACTUAL_POINTING_EL = numpy.array(
    [
        [0.60034796],
        [0.60060786],
        [0.61301855],
        [0.60034435],
        [0.60060094],
        [0.61300951],
        [0.600351],
        [0.60060378],
        [0.61302054],
        [0.60034232],
        [0.60060094],
        [0.61301433],
        [0.60034699],
        [0.6006015],
        [0.61301582],
    ]
)


# Commanded on-sky offsets in radians
ON_SKY_OFFSETS = numpy.array(
    [
        [[-2.44519379e-05, -3.59239723e-02]],
        [[-1.91864610e-05, -3.56595793e-02]],
        [[-9.07903986e-06, -2.32510502e-02]],
        [[-2.18320550e-05, -3.59263123e-02]],
        [[-1.54580914e-05, -3.56685393e-02]],
        [[8.09206074e-07, -2.32659502e-02]],
        [[-2.99308407e-05, -2.42848321e-02]],
        [[-1.95780549e-05, -2.40330593e-02]],
        [[-1.10789174e-05, -1.16140201e-02]],
        [[-2.17163108e-05, -2.42942523e-02]],
        [[-2.88373280e-05, -2.40301290e-02]],
        [[-5.21177965e-06, -1.16221602e-02]],
        [[-2.51344810e-05, -1.26534222e-02]],
        [[-1.43110891e-05, -1.23915593e-02]],
        [[-1.07291936e-05, 9.19986433e-06]],
    ]
)


# The antenna pointings in cross-elevation and elevation relative to
# the target. These are the x-parameter values required for the fitting
X_PER_SCAN = numpy.array(
    [
        [
            [-0.0030354, -0.46979683],
            [-0.0030354, -0.46979683],
            [-0.0030354, -0.46979683],
        ],
        [
            [-0.0017633, 0.25614331],
            [-0.0017633, 0.25614331],
            [-0.0017633, 0.25614331],
        ],
        [
            [-0.26866422, 0.09318612],
            [-0.26866422, 0.09318612],
            [-0.26866422, 0.09318612],
        ],
        [
            [0.27485065, 0.14506864],
            [0.27485065, 0.14506864],
            [0.27485065, 0.14506864],
        ],
        [[0.0, 0.0], [0.0, 0.0], [0.0, 0.0]],
    ]
)

# The un-normalised gain amplitudes. These are the required y-parameter
# values when fitting the primary beams to the gain amplitudes
Y_PER_SCAN_GAINS = numpy.array(
    [
        [
            [2.8977648, 2.91538241, 2.88337311, 2.87438061, 3.03981607],
            [2.94796547, 2.95113057, 2.93099455, 2.94831294, 3.12316639],
            [2.96784492, 2.9935797, 2.94780343, 2.95765879, 3.16071115],
            [2.73291878, 2.76053178, 2.72359799, 2.7349208, 2.94457866],
            [2.6963372, 2.72379267, 2.67694137, 2.69101844, 2.93270013],
            [2.80511528, 2.83216181, 2.78088726, 2.78875669, 3.06351404],
            [2.69317783, 2.71621302, 2.666415, 2.67996514, 2.98830095],
            [2.64831277, 2.67563763, 2.62276799, 2.63011444, 2.95970036],
            [2.56608136, 2.58142924, 2.54282112, 2.5418075, 2.90864697],
            [2.53897731, 2.55103603, 2.51009174, 2.51012405, 2.90035763],
            [2.40395155, 2.38708656, 2.34724905, 2.37823301, 2.75490573],
            [2.26326307, 2.22247577, 2.17775014, 2.23785456, 2.60283713],
            [2.15477948, 2.11115068, 2.07921681, 2.12716889, 2.49822925],
            [1.92648311, 1.88879467, 1.8795677, 1.89039466, 2.25526045],
            [1.64726399, 1.60841379, 1.59889733, 1.61013956, 1.93733201],
            [1.54612829, 1.48434048, 1.49139366, 1.50158781, 1.80918598],
        ],
        [
            [3.12015866, 3.13814675, 3.07753804, 3.10800208, 3.24163919],
            [3.08505, 3.12547038, 3.09944689, 3.09514514, 3.27540657],
            [3.0249616, 3.04495806, 3.00920609, 3.01532459, 3.22534899],
            [2.81662686, 2.83692983, 2.80416064, 2.80554635, 3.02341492],
            [2.75975104, 2.79068024, 2.74110843, 2.75543361, 2.99435928],
            [2.86670907, 2.87876895, 2.84283248, 2.82440745, 3.11488919],
            [2.75201287, 2.76061961, 2.7139166, 2.73056581, 3.04178406],
            [2.70710996, 2.74429266, 2.68492142, 2.68989234, 3.02579268],
            [2.63128763, 2.66266295, 2.63118512, 2.59667886, 2.98678585],
            [2.66233388, 2.67641461, 2.65121505, 2.62267501, 3.03810134],
            [2.47885837, 2.44795653, 2.43499361, 2.43426819, 2.83518609],
            [2.45217106, 2.38516984, 2.37136866, 2.40429389, 2.80841369],
            [2.37429951, 2.31440428, 2.30165248, 2.32326122, 2.74378223],
            [2.20802339, 2.16808951, 2.14655617, 2.15619647, 2.57860737],
            [1.95489615, 1.8916638, 1.91477759, 1.87523279, 2.28874003],
            [1.83261916, 1.74142457, 1.78367906, 1.73969501, 2.13513606],
        ],
        [
            [3.24704821, 3.27426858, 3.20547677, 3.19018759, 3.39478571],
            [3.25523999, 3.28381125, 3.22642816, 3.23787213, 3.43994699],
            [3.1700187, 3.20200776, 3.13474847, 3.15252519, 3.36887322],
            [2.92518023, 2.94038404, 2.88865111, 2.9073996, 3.13882744],
            [2.7741914, 2.81370884, 2.75047527, 2.77563296, 3.02340213],
            [2.86017951, 2.88123924, 2.81640357, 2.83607964, 3.118569],
            [2.73479665, 2.765961, 2.68970307, 2.72838172, 3.03469864],
            [2.68216945, 2.70568086, 2.66233548, 2.67746933, 2.99630742],
            [2.56126849, 2.58231207, 2.52032331, 2.54418883, 2.90543027],
            [2.50651048, 2.53003603, 2.46516051, 2.49412087, 2.86675848],
            [2.37655989, 2.36112115, 2.30961465, 2.36488597, 2.72199949],
            [2.23098022, 2.19348966, 2.15795874, 2.21346891, 2.56705828],
            [2.13125243, 2.0951278, 2.06598668, 2.10572606, 2.46840892],
            [1.96267287, 1.95017124, 1.92275311, 1.93492163, 2.31325002],
            [1.77187625, 1.73860417, 1.7313331, 1.72938317, 2.08875349],
            [1.63102314, 1.57375981, 1.57533047, 1.58153269, 1.91703853],
        ],
    ]
)


# Weights on the gains to be used for computing standard deviation
# on the gain amplitudes
GAINS_WEIGHTS_PER_SCAN = numpy.array(
    [
        [
            [
                428.57899893,
                498.9786941,
                392.35407172,
                422.97090126,
                514.52141871,
            ],
            [
                425.63718787,
                411.87462741,
                383.10642304,
                425.94969861,
                475.35478628,
            ],
            [
                460.22749146,
                510.30126268,
                401.31293729,
                489.28025336,
                574.86524539,
            ],
            [
                434.06823392,
                437.978944,
                359.97421576,
                416.35723297,
                459.57297851,
            ],
            [
                374.65334995,
                426.6826068,
                321.00710305,
                378.78918754,
                436.3749059,
            ],
            [
                250.43481981,
                260.04997893,
                192.09064378,
                246.31538051,
                317.33970147,
            ],
            [
                108.09762705,
                117.67373014,
                74.60126059,
                102.09311344,
                128.2103547,
            ],
            [
                110.26624893,
                121.25186999,
                88.60610868,
                121.94251475,
                149.18470821,
            ],
            [
                311.08146529,
                316.45117396,
                239.72494671,
                305.84955016,
                449.2687547,
            ],
            [
                389.72240419,
                402.7853834,
                288.10847421,
                357.64157486,
                507.40218331,
            ],
            [
                347.37901481,
                346.39796602,
                271.03141699,
                338.17613339,
                438.23987989,
            ],
            [
                284.01143539,
                307.42132039,
                231.04370209,
                306.72627202,
                423.17612236,
            ],
            [
                186.4606228,
                179.10990588,
                134.13102847,
                173.37719197,
                216.44066077,
            ],
            [68.52552695, 66.69949565, 62.24599376, 66.76337786, 103.7461927],
            [
                201.43313236,
                182.15334355,
                132.57026002,
                178.1728331,
                276.87515136,
            ],
            [
                150.99677496,
                161.0256711,
                142.33278523,
                139.77062871,
                203.35134887,
            ],
        ],
        [
            [
                343.35826475,
                392.52222384,
                356.08189396,
                335.27346306,
                410.04735036,
            ],
            [
                335.82065333,
                318.39768286,
                337.68419364,
                339.17562657,
                373.43105262,
            ],
            [
                364.62725195,
                402.19308906,
                374.52959719,
                386.62879565,
                451.78561012,
            ],
            [
                343.36183758,
                345.27557553,
                323.10192592,
                329.11965891,
                360.10571871,
            ],
            [
                291.79885292,
                335.35659911,
                289.32826746,
                299.06075409,
                339.96342556,
            ],
            [
                189.26781767,
                198.59088918,
                168.22346456,
                189.67738688,
                229.54750452,
            ],
            [84.47313611, 91.91927001, 64.04322631, 76.04331501, 94.93651696],
            [87.59767858, 96.16139527, 65.42588533, 94.72290335, 112.03614832],
            [
                243.28693108,
                246.72284608,
                207.12725485,
                241.92846602,
                353.8026097,
            ],
            [
                305.82738042,
                316.41802735,
                258.82195431,
                282.42818559,
                400.01095964,
            ],
            [
                273.84841018,
                272.33351862,
                253.42836594,
                267.2946458,
                344.19793204,
            ],
            [
                223.98399268,
                241.07093947,
                223.56930483,
                240.00478055,
                330.99211997,
            ],
            [
                147.28049509,
                140.90271825,
                137.7306177,
                136.46993914,
                170.99044799,
            ],
            [52.38912794, 48.60529098, 53.56456956, 51.87063453, 72.7003207],
            [
                160.08096988,
                145.09238591,
                124.17693751,
                140.78319933,
                217.41096549,
            ],
            [
                119.48973311,
                126.94773205,
                117.98346467,
                109.68251327,
                161.16750931,
            ],
        ],
        [
            [
                366.0878354,
                426.6941955,
                341.78321655,
                356.50638139,
                430.32954279,
            ],
            [
                360.16587225,
                345.39333272,
                362.85352917,
                361.35982783,
                400.73035149,
            ],
            [
                389.05125453,
                432.79228388,
                398.77192824,
                415.19482779,
                481.62591125,
            ],
            [
                365.45199858,
                369.38580336,
                356.48858988,
                350.47403685,
                385.28827857,
            ],
            [
                314.94341347,
                361.12964185,
                301.90420687,
                318.30855139,
                366.41272124,
            ],
            [
                208.35947199,
                218.09061371,
                180.01256799,
                205.1157547,
                247.74730656,
            ],
            [88.08357773, 92.85122869, 66.6142019, 80.07540714, 97.97162708],
            [89.76369356, 98.04398484, 70.25107289, 97.32680235, 118.31582911],
            [
                261.39362621,
                267.86485181,
                227.96759746,
                258.33574907,
                374.98197441,
            ],
            [
                332.16289204,
                343.42198615,
                276.32276426,
                305.53942042,
                431.15032758,
            ],
            [
                295.8223498,
                294.12423476,
                284.33343452,
                289.49518895,
                372.13502996,
            ],
            [
                243.15776909,
                261.15844338,
                245.40038605,
                260.66888969,
                358.42762159,
            ],
            [
                157.59615752,
                152.98988078,
                148.87259834,
                147.76559692,
                183.39993185,
            ],
            [56.48974763, 53.52734772, 52.51622569, 54.07828538, 79.85208631],
            [
                170.34488169,
                157.9286178,
                130.97752946,
                152.01289409,
                233.61276829,
            ],
            [
                128.50662718,
                136.78378624,
                128.92495139,
                119.58440002,
                174.20666078,
            ],
        ],
    ]
)


# Output fitted parameters in radians except the height
# and its uncertainty are dimensionless
CROSS_EL_OFFSET = numpy.array([-0.00049307, -0.00037015, -0.0010227])
CROSS_EL_OFFSET_STD = numpy.array([0.00168131, 0.00171503, 0.00247743])
EL_OFFSET = numpy.array([-0.00038882, -0.0002263, -0.00030735])
EL_OFFSET_STD = numpy.array([0.00045358, 0.0005212, 0.00061709])
EXPECTED_WIDTH_H = numpy.array([0.03341499, 0.03335993, 0.03338742])
EXPECTED_WIDTH_V = numpy.array([0.0382184, 0.03815542, 0.03818686])
FITTED_WIDTH_H = numpy.array([0.03649301, 0.03423172, 0.03651669])
FITTED_WIDTH_H_STD = numpy.array([0.00353479, 0.00359349, 0.00505895])
FITTED_WIDTH_V = numpy.array([0.03729794, 0.03554818, 0.0361198])
FITTED_WIDTH_V_STD = numpy.array([0.00133215, 0.0014045, 0.00171055])
FITTED_HEIGHT = numpy.array([0.00093234, 0.00093131, 0.00101095])
FITTED_HEIGHT_STD = numpy.array(
    [2.31535379e-05, 2.64222487e-05, 3.93277949e-05]
)
OUTPUT_POINTING_OFFSETS = {
    "antenna_names": numpy.array(ANTENNA_NAME),
    "xel_offset": CROSS_EL_OFFSET,
    "xel_offset_std": CROSS_EL_OFFSET_STD,
    "el_offset": EL_OFFSET,
    "el_offset_std": EL_OFFSET_STD,
    "expected_width": numpy.column_stack((EXPECTED_WIDTH_H, EXPECTED_WIDTH_V)),
    "fitted_width": numpy.column_stack((FITTED_WIDTH_H, FITTED_WIDTH_V)),
    "fitted_width_std": numpy.column_stack(
        (FITTED_WIDTH_H_STD, FITTED_WIDTH_V_STD)
    ),
    "fitted_height": FITTED_HEIGHT,
    "fitted_height_std": FITTED_HEIGHT_STD,
}


class MockBaseTable:
    """
    Mock Base Table Class
    """

    def getcol(self, columnname=None):
        """
        Get column name
        """
        if columnname == "TIME":
            return VIS_TIMESTAMPS_MJD

        if columnname == "INTERVAL":
            return numpy.array([10.0])

        if columnname == "CPARAM":
            return numpy.ones((NTIMES, NANTS, NCHAN, 1))

        if columnname == "ANTENNA1":
            return numpy.array([0, 1, 2])

        if columnname == "SPECTRAL_WINDOW_ID":
            return numpy.array([0, 1])

        if columnname == "DATA":
            vis_3d = VIS[:, numpy.newaxis, :].repeat(NCHAN, axis=1)
            return numpy.array(vis_3d.reshape((NCORR, NCHAN, NPOL)))

        if columnname == "WEIGHT":
            return numpy.array(VIS_WEIGHTS.reshape((NCORR, NPOL)))


class MockDataDescriptionTable:
    """
    Mock Data Description Table Class
    """

    def getcol(self, columnnname=None):
        """
        Get column name
        """
        if columnnname == "SPECTRAL_WINDOW_ID":
            return numpy.array([0])


class MockSpectralWindowTable:
    """
    Mock Spectral Window Table Class
    """

    def getcol(self, columnname=None):
        """
        Get column name
        """
        if columnname == "CHAN_FREQ":
            return numpy.array([FREQS])

        if columnname == "NUM_CHAN":
            return numpy.array([NCHAN])


class MockAntennaTable:
    """
    Mock Antenna Table Class
    """

    def getcol(self, columnname=None):
        """
        Get column name from MS File
        """
        if columnname == "NAME":
            return ["ANT1", "ANT2", "ANT3"]

        if columnname == "MOUNT":
            return MOUNT

        if columnname == "DISH_DIAMETER":
            return DIAMETER

        if columnname == "POSITION":
            return numpy.array(
                [
                    [-1601162.0, -5042003.0, 3554915.0],
                    [-1601192.0190292, -5042007.78341262, 3554960.73493029],
                    [-1601147.19047704, -5042040.12425644, 3554894.80919799],
                ]
            )

        if columnname == "OFFSET":
            return OFFSET

        if columnname == "STATION":
            return ANTENNA_NAME


class MockPolarisationTable:
    """
    Mock Polarisation Table Class
    """

    def getcol(self, columnname=None):
        """
        Get column name
        """
        if columnname == "CORR_TYPE":
            return numpy.array([9, 12])


class MockPointingTable:
    """
    Mock Pointing Table Class
    """

    def getcol(self, columnname=None):
        """
        Get column name
        """
        if columnname == "TARGET":
            return numpy.dstack((COMMANDED_POINTING_AZ, COMMANDED_POINTING_EL))

        if columnname == "DIRECTION":
            return numpy.dstack((ACTUAL_POINTING_AZ, ACTUAL_POINTING_EL))

        if columnname == "SOURCE_OFFSET":
            return ON_SKY_OFFSETS

        if columnname == "TIME":
            return POINTING_TIMESTAMPS_MJD
